using System;
using System.Collections.Generic;
using System.Text;

namespace Sketcher
{
    abstract class AnimationBehavior : Behavior
    {
        public AnimationBehavior(Object target) : base(target) 
        {
            Connect();
        }

        //! connect this behavior to the world
        override public void Connect() {
            AnimationBehaviorManager.Get.Register(this);
        }

        //! disconnect this behavior from the world
        override public void Disconnect( ) {
            AnimationBehaviorManager.Get.DeRegister( this );
        }

        virtual public void OnStart() {
        }
        virtual public void OnStop() {
        }

    }


    /*
     * "versions" of class with different types of target
     */

    abstract class RenderableAnimationBehavior : AnimationBehavior
    {
        public RenderableAnimationBehavior(Renderable target)
            : base(target) {
        }

        public Renderable RTarget {
            get { return (Renderable)Target; }
        }
    }

}