using System;
using System.Collections.Generic;
using System.Text;

namespace Sketcher
{
    class BehaviorSet
    {
        List<InputBehavior> m_vInputs;
        List<TransitionBehavior> m_vTransitions;
        List<AnimationBehavior> m_vAnimations;
        List<RenderingBehavior> m_vRenders;

        public BehaviorSet() {
            m_vInputs = new List<InputBehavior>();
            m_vTransitions = new List<TransitionBehavior>();
            m_vAnimations = new List<AnimationBehavior>();
            m_vRenders = new List<RenderingBehavior>();
        }

        public List<InputBehavior> InputBehaviors {
            get { return m_vInputs; }
        }
        public List<TransitionBehavior> TransitionBehaviors {
            get { return m_vTransitions; }
        }
        public List<AnimationBehavior> AnimationBehaviors {
            get { return m_vAnimations; }
        }
        public List<RenderingBehavior> RenderingBehaviors {
            get { return m_vRenders; }
        }

        public void Add(InputBehavior behavior) {
            m_vInputs.Add(behavior);
        }
        public void Add(TransitionBehavior behavior) {
            m_vTransitions.Add(behavior);
        }
        public void Add(AnimationBehavior behavior) {
            m_vAnimations.Add(behavior);
        }
        public void Add(RenderingBehavior behavior) {
            m_vRenders.Add(behavior);
        }


        public void Connect() {
            foreach (InputBehavior i in m_vInputs)
                i.Connect();
            foreach (TransitionBehavior t in m_vTransitions)
                t.Connect();
            foreach (AnimationBehavior a in m_vAnimations)
                a.Connect();
            foreach (RenderingBehavior r in m_vRenders)
                r.Connect();
        }

        public void Disconnect( ) {
            foreach (InputBehavior i in m_vInputs)
                i.Disconnect();
            foreach (TransitionBehavior t in m_vTransitions)
                t.Disconnect();
            foreach (AnimationBehavior a in m_vAnimations)
                a.Disconnect();
            foreach (RenderingBehavior r in m_vRenders)
                r.Disconnect();
        }
    }
}
