using System;
using System.Collections.Generic;
using System.Text;

namespace Sketcher
{
    class RadialMenu : Widget
    {
        Circle2f m_circle;

        public RadialMenu(Vector2f vPosition, float fRadius, Item parent) : base(parent) {
            m_circle = new Circle2f(vPosition, fRadius);
        }

        public Vector2f Center {
            get { return m_circle.Center; }
            set { m_circle.Center = value; }
        }

        /*
         * Widget Overrides
         */

        override public Box2f Bounds {
            get { return m_circle.Bounds; }
        }

        override public void Render() {
            RenderEngine.Get.DrawCircle(m_circle, ColorRGBA.DARKGREY);
            RenderEngine.Get.DrawCircle(m_circle.Center, m_circle.Radius-2.0f, ColorRGBA.WHITE);
        }


        /*
         * InputRegion overrides
         */ 
/*
        //! return value in [0,1] to indicate desire for capturing stroke
        override public float WantCapture(Stroke s) {
            if ( Bounds.Contains(s[ s.Count-1 ] ) )
                return InputRegion.NO_CAPTURE;
            return 0.0f;
        }
*/
    }
}
