using System;
using System.Collections.Generic;
using System.Text;

namespace Sketcher
{
    public enum VisibilityState {
        Visible,
        Hidden,
        TransitioningToVisible,
        TransitioningToHidden
    };
 
    interface Renderable
    {
        //! these should strictly be properties, as they will be set repeatedly by animations, behaviors, etc...
        //! (ie, avoid sending events from them...)

        VisibilityState Visibility { get; set; }
        float Opacity { get; set; }
        ColorRGBA ForegroundColor { get; set; }
        ColorRGBA BackgroundColor { get; set; }

        //! RenderBackground is called for all renderables in a container, before calling
        //! Render(), to give them a chance to draw backgrounds (drop-shadows, etc)
        void RenderBackground();

        void Render();
    }
}
