using System;
using System.Collections.Generic;
using System.Text;

namespace Sketcher
{
    class Button : Item
    {
        protected IconSet m_icons;
        protected bool m_bDrawBorder;
        protected bool m_bDrawIcon;

        public Button( float fWidth, float fHeight ) {
            BackgroundColor = ColorRGBA.WHITE;
            ForegroundColor = ColorRGBA.DARKGREY;
            m_bDrawBorder = true;
            m_bDrawIcon = true;

            m_icons = new IconSet();

            Resize( new Box2f( fWidth, fHeight ) );
        }

        public bool DrawBorder {
            get { return m_bDrawBorder; }
            set { m_bDrawBorder = value; }
        }

        public bool DrawIcon {
            get { return m_bDrawIcon; }
            set { m_bDrawIcon = value; }
        }

        public IconSet Icons {
            get { return m_icons; }
        }


        // [RMS] TODO: draw border using Geometry (then we don't need to override Render everywhere)
        //! draw object
        override public void Render( ) {

            RenderEngine.Get.DrawBox( Bounds, AlphaBackgroundColor );

            if (m_bDrawIcon) {
                Icon useIcon = Icons.GetBestIcon(IconSet.IconState_Enabled, Bounds);
                useIcon.Draw(Bounds, Opacity);
            }

            if ( m_bDrawBorder )
                RenderEngine.Get.DrawBoxOutline( Bounds, AlphaForegroundColor );
        }
    }
}
