using System;
using System.Collections.Generic;
using System.Text;

namespace Sketcher
{
    class Blob
    {
        Vector2f m_center;
        float m_fOuterRadius;
        float m_fInnerRadius;

        Box2f m_bounds;

        public Blob( ) {
            m_center = Vector2f.ZERO;
            m_fInnerRadius = 0.0f;
            m_fOuterRadius = 1.0f;
            Update();
        }

        public Box2f Bounds {
            get { return m_bounds; }
        }

        public Vector2f Center {
            get { return m_center; }
            set { m_center = value; Update(); }
        }

        public float InnerRadius {
            get { return m_fInnerRadius; }
            set { m_fInnerRadius = value; }
        }

        public float OuterRadius {
            get { return m_fOuterRadius; }
            set { m_fOuterRadius = value; Update(); }
        }

        public float Value( Vector2f v ) {
            float fT = (v - m_center).SquaredLength;
            if (fT > m_fOuterRadius*m_fOuterRadius)
                return 0.0f;
            if (fT < m_fInnerRadius*m_fInnerRadius)
                return 1.0f;
            fT = (float)Math.Sqrt( fT ) - m_fInnerRadius;
            float fR = m_fOuterRadius - m_fInnerRadius;
            fT /= fR;
            fT = 1 - fT*fT;
            return fT*fT*fT;
        }



        void Update( ) {
            m_bounds = new Box2f( m_center, m_fOuterRadius );
        }


    }
}
