using System;
using System.Collections.Generic;
using System.Text;

namespace Sketcher
{
    class CircleStroke
    {
        Stroke m_stroke;
        Vector2f m_vCenter;

        public CircleStroke(Stroke s) {
            m_stroke = s;

            m_vCenter = Vector2f.ZERO;
            for (int i = 0; i < s.Count; ++i) {
                m_vCenter += s[i];
            }
            m_vCenter *= 1.0f / (float)s.Count;
        }

        public Box2f Bounds {
            get { return m_stroke.Bounds; }
        }

        public Vector2f Center {
            get { return m_vCenter; }
        }

        public Stroke Stroke {
            get { return m_stroke; }
        }
    }
}
