using System;
using System.Collections.Generic;
using System.Text;

namespace Sketcher
{
    class Selection : BehaviorTarget
    {
        ItemSet m_items;

        public Selection() {
            m_items = new ItemSet();
        }

        public ItemSet Items {
            get { return m_items; }
        }

        public bool IsSelected(Item i) {
            return m_items.Contains(i);
        }

        public int Count {
            get { return m_items.Count; }
        }

        public void ClearSelection() {
            m_items.Clear();
        }

        public void SelectItem(Item i, bool bAppend) {
            if (!bAppend)
                m_items.Clear();
            m_items.Add(i);
        }

    }
}
