using System;
using System.Collections.Generic;
using System.Text;
using System.Xml;

namespace Sketcher
{
    abstract class VectorGraphicsItem : Item
    {
        virtual public float IsHit(Vector2f vClick) {
            return Bounds.Contains(vClick) ? 1.0f : 0.0f;
        }

        virtual public string TypeName {
            get { return "VectorItem"; }
        }

        abstract public VectorGraphicsItem Copy();
        abstract public bool Set(VectorGraphicsItem to);

        virtual public bool Erase( Blob eraserBlob ) { return false; }
        virtual public List<VectorGraphicsItem> Optimize( ) { return null; }

        //! [RMS] should we be storing all history events at once??
        virtual public void NotifySizeChanged() {
        }


        virtual public bool Store( XmlDocument doc, XmlElement item_node ) { return false; }
        virtual public bool Restore( XmlDocument doc, XmlElement item_node ) { return false; }

    }
}
