using System;
using System.Collections.Generic;
using System.Text;

namespace Sketcher {
    class VectorToolSet {

        VectorCanvas m_canvas;
        List<VectorTool> m_vTools;
        VectorTool m_selectedTool;

        public VectorToolSet(VectorCanvas canvas) {
            m_canvas = canvas;
            m_vTools = new List<VectorTool>();
            m_selectedTool = null;
        }

        public VectorTool SelectedTool {
            get { return m_selectedTool; }
        }

        public string SelectedToolName {
            get { return (m_selectedTool != null) ? m_selectedTool.Name : "Unknown"; }
        }

        public void AddTool(VectorTool tool) {
            m_vTools.Add(tool);
            m_canvas.Behaviors.Add(tool);
            tool.Disable();
        }

        public bool SelectTool(string toolName) {
            if ( m_selectedTool != null )
                m_selectedTool.Disable();
            m_selectedTool = null;

            VectorTool found = m_vTools.Find( delegate(VectorTool item) { return item.Name == toolName; } );
            if (found != null) {
                m_selectedTool = found;
                m_selectedTool.Enable();
                return true;
            }
            return false;
        }

    }
}
